module fileoutput

implicit none

contains

subroutine AtomNumberToName(Z, name)
    integer :: Z;
    character(len=2) :: name;
    
    if(Z==1)then
        name='H';
    elseif(Z==2)then
        name='He';
    elseif(Z==3)then
        name='Li';
    elseif(Z==4)then
        name='Be';
    elseif(Z==5)then
        name='B';
    elseif(Z==6)then
        name='C';
    elseif(Z==7)then
        name='N';
    elseif(Z==8)then
        name='O';
    elseif(Z==9)then
        name='F';
    elseif(Z==10)then
        name='Ne';
    elseif(Z==11)then
        name='Na';
    elseif(Z==12)then
        name='Mg';
    elseif(Z==13)then
        name='Al';
    elseif(Z==14)then
        name='Si';
    elseif(Z==15)then
        name='P';
    elseif(Z==16)then
        name='S';
    elseif(Z==17)then
        name='Cl';
    elseif(Z==18)then
        name='Ar';
    elseif(Z==19)then
        name='K';
    elseif(Z==20)then
        name='Ca';
    elseif(Z==21)then
        name='Sc';
    elseif(Z==22)then
        name='Ti';
    elseif(Z==23)then
        name='V';
    elseif(Z==24)then
        name='Cr';
    elseif(Z==25)then
        name='Mn';
    elseif(Z==26)then
        name='Fe';
    elseif(Z==27)then
        name='Co';
    elseif(Z==28)then
        name='Ni';
    elseif(Z==29)then
        name='Cu';
    elseif(Z==30)then
        name='Zn';
    elseif(Z==31)then
        name='Ga';
    elseif(Z==32)then
        name='Ge';
    elseif(Z==33)then
        name='As';
    elseif(Z==34)then
        name='Se';
    elseif(Z==35)then
        name='Br';
    elseif(Z==36)then
        name='Kr';
    elseif(Z==37)then
        name='Rb';
    elseif(Z==38)then
        name='Sr';
    elseif(Z==39)then
        name='Y';
    elseif(Z==40)then
        name='Zr';
    elseif(Z==41)then
        name='Nm';
    elseif(Z==42)then
        name='Mo';
    elseif(Z==43)then
        name='Tc';
    elseif(Z==44)then
        name='Ru';
    elseif(Z==45)then
        name='Rh';
    elseif(Z==46)then
        name='Pd';
    elseif(Z==47)then
        name='Ag';
    elseif(Z==48)then
        name='Cd';
    elseif(Z==49)then
        name='In';
    elseif(Z==50)then
        name='Sn';
    elseif(Z==51)then
        name='Sb';
    elseif(Z==52)then
        name='Te';
    elseif(Z==53)then
        name='I';
    elseif(Z==54)then
        name='Xe';
    elseif(Z==55)then
        name='Cs';
    elseif(Z==56)then
        name='Ba';
    elseif(Z==57)then
        name='La';
    elseif(Z==58)then
        name='Ce';
    elseif(Z==59)then
        name='Pr';
    elseif(Z==60)then
        name='Nd';
    elseif(Z==61)then
        name='Pm';
    elseif(Z==62)then
        name='Sm';
    elseif(Z==63)then
        name='Eu';
    elseif(Z==64)then
        name='Gd';
    elseif(Z==65)then
        name='Tb';
    elseif(Z==66)then
        name='Dy';
    elseif(Z==67)then
        name='Ho';
    elseif(Z==68)then
        name='Er';
    elseif(Z==69)then
        name='Tm';
    elseif(Z==70)then
        name='Yb';
    endif
    name = trim(adjustr(name));            
endsubroutine

subroutine OutputRadialFunc(nGraphRes, dGraphTo, nMatSize, bas, EigVecs, elecs, Z,nNumElecs, n, l, ms)
    integer :: nGraphRes, nMatSize, elecs(1:103,4), nNumElecs,Z;
    integer :: n,l,ms;
    doubleprecision :: dGraphTo, bas(30,0:3), EigVecs(:,:);
    
    doubleprecision :: r, dRadial;
    integer :: i,k,j;
    character(len=40) :: filenm;
    character(len=2) :: chn,chZ;
    character :: chl,chms;
    
    
    if(l==0)then
        chl='s';
    elseif(l==1)then
        chl='p';
    elseif(l==2)then
        chl='d';
    elseif(l==3)then
        chl='f';
    endif;
    
    if(ms==1)then
        chms='U';
    else
        chms='D';        
    endif
    
    write(chn,'(I1)') n;
    call AtomNumberToName(Z,chZ);
    
    filenm=trim(adjustl(chZ))//'_'//trim(adjustl(chn))//chl//'_'//chms;
    filenm='Results\'//filenm;
    filenm=trim(filenm)//'.txt';
    
    open(unit=2,file=trim(adjustl(filenm)));
    write(2,*) nGraphRes,dGraphTo;
    write(2,*);

    do i=1,nNumElecs
        if(elecs(i,1)==n .and. elecs(i,2)==l .and. elecs(i,3)==0 .and. elecs(i,4)==ms)then
            r = 0;
            do k=1,nGraphRes                
                dRadial = 0;
                do j=1,nMatSize
                    dRadial = dRadial + EigVecs(j,i)*r**elecs(i,2)*exp(-bas(j,elecs(i,2))*r*r);
                enddo
                write(2,*) r,dRadial;
                r = r + dGraphTo/nGraphRes;
            enddo
        endif
    enddo
    
    close(2);    
end subroutine



subroutine OutputEigenVecs(basc, elecs, EigVecs, Z, nNumElecs)
    integer :: basc(0:3), elecs(1:103,4), nNumElecs, Z;
    doubleprecision :: EigVecs(:,:);
    
    character(len=40) :: filenm;
    character(len=2) :: chn,chZ,chq;
    character :: chl,chms;
    integer :: n,l,ml,ms;
    integer :: i,j;
    
    
    do i=1,nNumElecs
        n=elecs(i,1);
        l=elecs(i,2);
        ml=elecs(i,3);
        ms=elecs(i,4);
        
        if(l==0)then
            chl='s';
        elseif(l==1)then
            chl='p';
        elseif(l==2)then
            chl='d';
        elseif(l==3)then
            chl='f';
        endif;
        
        if(ms==1)then
            chms='U';
        else
            chms='D';        
        endif
        
        if(Z-nNumElecs==0)then
            chq='N';
        elseif(Z-nNumElecs==1)then
            chq='1+';
        elseif(Z-nNumElecs==2)then
            chq='2+';
        elseif(Z-nNumElecs==3)then
            chq='3+';
        endif
            
        write(chn,'(I1)') n;
        call AtomNumberToName(Z,chZ);
        
        filenm='EigV_'//trim(adjustl(chZ))//'_'//trim(adjustl(chq))//'_'//trim(adjustl(chn))//chl//'_'//chms;
        filenm=trim(filenm)//'.txt';
        
        open(unit=2,file='Results\'//trim(adjustl(filenm)));
        write(2,*) filenm
        write(2,*) trim(adjustl(chn))//chl//chms;
        write(2,'(I2)') basc(elecs(i,2))
        do j=1,basc(elecs(i,2))
            write(2,*) EigVecs(j,i);
        enddo
        close(2);
    enddo 
end subroutine

subroutine OutputBasis(Z,bas,basc)
    double precision :: bas(30,0:3);
    integer :: basc(0:3),Z;
    
    character(len=30) :: filenm;
    character(len=2) :: chZ;
    integer :: i,j;
    
    do i=0,3
        if(i==0)then
            filenm='s';
        elseif(i==1)then
            filenm='p';
        elseif(i==2)then
            filenm='d';
        elseif(i==3)then
            filenm='f';
        endif
        
        call AtomNumberToName(Z,chZ);
        filenm='Bas_'//trim(adjustl(chZ))//'_'//trim(adjustl(filenm));
        
        open(2, file=trim(adjustl('Results\'//filenm))//'.txt');
        write(2,*) filenm
        write(2,'(I2)') basc(i);
        do j=1,basc(i)
            write(2,*) bas(j,i);
        enddo
        close(2);        
    enddo    
endsubroutine

endmodule